#ifndef __quat_left_div_c /* Copyright Bill.Triggs@inrialpes.fr */
#define __quat_left_div_c "$ Fri Jul 21 12:05:22 2000 $"
/** NO WARRANTY. Use & distribute freely. Fixes/feedback welcome. **/
/*------------------------------------------------------------------------
  Left division of quaternions: q = qa^-1 * qb, where qa^-1 =
  bar(qa)/|qa|^2 is the conjugate inverse of qa.
  ------------------------------------------------------------------------*/
#include "geom23.h"

double*
quat_left_div(double q[4], double qa[4], double qb[4])
{
  double qt[4], norm = 1.0/v4sq(qa);
  if (q == qa) { acopy(double,qt,qa,4); qa = qt; }
  if (q == qb) { acopy(double,qt,qb,4); qb = qt; }
  
  q[X] = norm*(-qa[Y]*qb[Z] + qa[Z]*qb[Y] + qa[W]*qb[X] - qa[X]*qb[W]);
  q[Y] = norm*(-qa[Z]*qb[X] + qa[X]*qb[Z] + qa[W]*qb[Y] - qa[Y]*qb[W]);
  q[Z] = norm*(-qa[X]*qb[Y] + qa[Y]*qb[X] + qa[W]*qb[Z] - qa[Z]*qb[W]);
  q[W] = norm*( qa[W]*qb[W] + qa[X]*qb[X] + qa[Y]*qb[Y] + qa[Z]*qb[Z]);
  return q;
}

#endif /*__quat_left_div_c */
