#ifndef __rot_to_quat_c /* Copyright Bill.Triggs@inrialpes.fr */
#define __rot_to_quat_c "$ Fri Jul 21 12:43:02 2000 $"
/** NO WARRANTY. Use & distribute freely. Fixes/feedback welcome. **/
/*------------------------------------------------------------------------
  Convert a 3x3 rotation matrix to the corresponding quaternion.  The
  real part is 1/2*sqrt(1+tr(R)), and the skew-matrix form of the vector
  part is (R-R')/(2*sqrt(1+tr(R))), where tr() is trace.
  
  FIXME: The solution is singular and flips q <-> -q for 180 degree
  rotations about any axis (a->0). We could probably handle this more
  gracefully, but a discontinuity somewhere is inevitable.
  ------------------------------------------------------------------------*/
#include "geom23.h"

double*
rot_to_quat(double q[4], double R[3][3])
{
  double a = 1.0 + R[X][X]+R[Y][Y]+R[Z][Z], 
    c = 2.0*sqrt((a>=1e-14)? a:1e-14);
  q[X] = (R[Z][Y]-R[Y][Z])/c;
  q[Y] = (R[X][Z]-R[Z][X])/c;
  q[Z] = (R[Y][X]-R[X][Y])/c;
  q[W] = c/4.0;
  return q;
}

#endif /*__rot_to_quat_c */
